import _objectSpread from "@babel/runtime/helpers/esm/objectSpread";
import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import React, { memo } from "react";
import SidebarBoxContainer from "../SidebarBoxContainer";
import DescriptionIcon from "@mui/icons-material/Description";
import { styled } from "@mui/material/styles";
import { createTheme, ThemeProvider } from "@mui/material/styles";
import { grey } from "@mui/material/colors";
import { Box, Typography } from "@mui/material";
import CircleIcon from "@mui/icons-material/Circle";
import { useEffect, useState } from "react";
import NoDescriptionInfo from "../NoDescriptionInfo";
import TrashIcon from "@mui/icons-material/Delete";
var theme = createTheme();
var MarkdownContainer = styled("div")(function (_ref) {
  var theme = _ref.theme;
  return {
    paddingLeft: 16,
    paddingRight: 16,
    fontSize: 12,
    "& h1": {
      fontSize: 18
    },
    "& h2": {
      fontSize: 14
    },
    "& h3": {
      fontSize: 12
    },
    "& h4": {
      fontSize: 12
    },
    "& h5": {
      fontSize: 12
    },
    "& h6": {
      fontSize: 12
    },
    "& p": {
      fontSize: 12
    },
    "& a": {},
    "& img": {
      width: "100%"
    }
  };
});
export var TaskDescriptionSidebarBox = function TaskDescriptionSidebarBox(_ref2) {
  var _selectedImage$region3;

  var description = _ref2.description,
      state = _ref2.state,
      dispatch = _ref2.dispatch;
  var selectedImage = state.images[state.selectedImage];

  var _useState = useState(null),
      _useState2 = _slicedToArray(_useState, 2),
      hasDescription = _useState2[0],
      setHasDescription = _useState2[1];

  useEffect(function () {
    var _selectedImage$region;

    if ((_selectedImage$region = selectedImage.regions) === null || _selectedImage$region === void 0 ? void 0 : _selectedImage$region.length) {
      var _selectedImage$region2;

      var anyDescription = selectedImage === null || selectedImage === void 0 ? void 0 : (_selectedImage$region2 = selectedImage.regions) === null || _selectedImage$region2 === void 0 ? void 0 : _selectedImage$region2.filter(function (region) {
        if (!region.comment) {
          return region;
        }
      }); // console.log(anyDescription.length)

      setHasDescription(anyDescription === null || anyDescription === void 0 ? void 0 : anyDescription.length);
    } else {
      setHasDescription(null);
    }
  }, [selectedImage]);
  return React.createElement(ThemeProvider, {
    theme: theme
  }, React.createElement(SidebarBoxContainer, {
    info: hasDescription > 0 ? React.createElement(NoDescriptionInfo, {
      selectedImage: selectedImage,
      dispatch: dispatch
    }) : null,
    title: "Descriptions",
    icon: React.createElement(DescriptionIcon, {
      style: {
        color: grey[700]
      }
    }),
    expandedByDefault: true
  }, React.createElement(MarkdownContainer, null, selectedImage === null || selectedImage === void 0 ? void 0 : (_selectedImage$region3 = selectedImage.regions) === null || _selectedImage$region3 === void 0 ? void 0 : _selectedImage$region3.map(function (region) {
    return region.comment && React.createElement(Box, {
      key: region.id,
      onClick: function onClick() {
        var regionIndex = selectedImage.regions.findIndex(function (r) {
          return r.id === region.id;
        });
        dispatch({
          type: "SELECT_REGION",
          region: selectedImage.regions[regionIndex]
        });
      },
      sx: {
        display: "flex",
        alignItems: "center",
        gap: "6px",
        p: "5px",
        cursor: "pointer",
        "&:hover": {
          bgcolor: "#e3f2fd",
          color: "#424242"
        },
        bgcolor: region.editingLabels && region.highlighted ? "#BBDEFB" : "transparent",
        overflow: "hidden",
        position: "relative"
      }
    }, React.createElement(CircleIcon, {
      sx: {
        color: region.color
      },
      fontSize: "small"
    }), React.createElement(Typography, null, region.comment), React.createElement(TrashIcon, {
      fontSize: "small",
      onClick: function onClick() {
        var regionIndex = selectedImage.regions.findIndex(function (r) {
          return r.id === region.id;
        });

        var newRegion = _objectSpread({}, selectedImage.regions[regionIndex], {
          comment: ""
        });

        dispatch({
          type: "CHANGE_REGION",
          region: newRegion
        });
      },
      sx: {
        ml: "auto",
        position: "absolute",
        right: "6px"
      }
    }));
  }))));
};
export default memo(TaskDescriptionSidebarBox);